library Demo_p;

uses
  forms,
  winprocs,wintypes,
  Dllif,
  Demoform in 'DEMOFORM.PAS' {BeepQuery},
  Nothrtst in 'NOTHRTST.PAS' {AnotherTest};

function LPSZ(var s: {Open}String): PChar;
{ Long Pointer String Zero
  gives pointer to ASCIIZ at s[1] and appends a terminating #0 to s.
  deletes last character of s if the terminating #0 wouldn't fit }
begin
  if Length(S) >= High(s) then s[0]:=char(High(s)-1);
  s[Length(s)+1] := #0;
  LPSZ := @s[1];
end;
function Strip(X: string): string;
{ Strip leading and trailing blanks.}
  var
    First, Last: integer;
  begin
    First := 1;
    while X[First] = ' ' do
      inc(First);
    Last := Length(X);
    while X[Last] = ' ' do
      Dec(Last);
    Strip := Copy(X, First, Last - First + 1);
  end;
function Int2Str(L: longint): string;
{ Converts an integer to a string for use with OutText, OutTextXY }
  var
    S: string;
  begin
    Str(L, S);
    Int2Str := Strip(S);
  end; { Int2Str }

{$IFDEF LOG}
var
  dllecho:text;
procedure log(proc:string;action:integer;dll_handle:string);
var
  buf:string;
begin
   buf:=int2str(action)+' '+dll_handle+' '+proc;
   writeln(dllecho,buf);
   application.messagebox(lpsz(buf),'from dll log',0);
end;
{$ENDIF}

  var
    Data:text;
    NextTime:tExportClock;
    NextName:tNodeName;

  procedure Remote
    (
      Action: integer;                   {what is being done at the moment}
      Clock: tExportClock;               {simulation clock reading}
      var DLL_Handle: tNodeName;         {The handle you gave in the setup}
      var Delay: tExportClock;           {simulation clock reading (NOTE)}
      var Status: integer;               {flag you set to tell what to do next}
      var Transaction: tTransactionData  {address of the transaction record}
    ); export;
   begin
   {$IFDEF LOG}
     log('Remote',action,dll_handle);
   {$ENDIF}
     case Action of
       ConnectorProbe:if BeepQuery.BeepOnCall.checked then
         begin
           messagebeep(0);
         end;
       Edit:BeepQuery.showmodal;
       TransactionStart:
         begin
           Status:=NoAction;
           if NextTime>Clock then exit;
           if EOF(Data) then exit;
           Transaction.Name:=strip(NextName);
           Readln(Data,NextTime,NextName);
           Status:=Start;
         end;
     end;
   end;
  procedure Setup
    (
      Action: integer;                   {what is being done at the moment}
      Clock: tExportClock;               {simulation clock reading}
      var DLL_Handle: tNodeName;         {The handle you gave in the setup}
      var Delay: tExportClock;           {simulation clock reading (NOTE)}
      var Status: integer;               {flag you set to tell what to do next}
      var Transaction: tTransactionData  {address of the transaction record}
    ); export;
   begin
   {$IFDEF LOG}
     log('Setup',action,dll_handle);
   {$ENDIF}
     AnotherTest.caption:=DLL_Handle;
     case Action of
       StartRun:
       begin
         reset(Data);
         Readln(Data,NextTime,NextName);
       end;
       DestroyModel:
         try
           CloseFile(Data);
         except
         end;
       Edit:AnotherTest.showmodal;
     end;
   end;
function Gaussian(Mean,Variance:double): double;far; external 'randlib';
  procedure Delays
    (
      Action: integer;                   {what is being done at the moment}
      Clock: tExportClock;               {simulation clock reading}
      var DLL_Handle: tNodeName;         {The handle you gave in the setup}
      var Delay: tExportClock;           {simulation clock reading (NOTE)}
      var Status: integer;               {flag you set to tell what to do next}
      var Transaction: tTransactionData  {address of the transaction record}
    ); export;
    begin
     {$IFDEF LOG}
     log('Delays',action,dll_handle);
     {$ENDIF}
      if action<>SetDelay then exit;
      if Transaction.Name = 'MOOSE' then Delay := gaussian(15.0,1.0);
      if Transaction.Name = 'COW' then Delay := gaussian(5.0,1.0);
    end;

{The following line does nothing but force a compile time check
 of the interface}
const
  ForceTypecheck1:DLLProcCall=remote;
  ForceTypecheck2:DLLProcCall=setup;

exports
  Remote index 1,
  Delays index 2,
  Setup  index 3;

var
  SaveExit: Pointer;
procedure LibExit; far;
begin
  {$IFDEF LOG}
  log('LibExit',999,'Shutdown');
  closefile(dllecho);
  {$ENDIF}
  if ExitCode = wep_System_Exit then
  begin
      { System shutdown in progress }
  end else
  begin
      { DLL is unloaded }
  end;
  ExitProc := SaveExit;
end;
begin
  { Perform DLL initialization }
  SaveExit := ExitProc;     { Save old exit procedure pointer }
  ExitProc := @LibExit;     { Install LibExit exit procedure }
  Application.CreateForm(TBeepQuery, BeepQuery);
  Application.CreateForm(TAnotherTest, AnotherTest);
  {$IFDEF LOG}
  AssignFile(dllecho,'DLLECHO.txt');
  rewrite(dllecho);
  {$ENDIF}
  FileMode:=0 {ReadOnly};
  AssignFile(Data,'TRANS.DAT');
  {lib initialization goes here}
end.
