#include <windows.h>

/*
   This interface was written in plain vanilla C.
   You are probably working in C++. Peace.
   Going up is easy, going back is not.
*/

/* From the manual:
     Type           Range                  Digits    Bytes
    Double   5.0 * 10-324 .. 1.7 * 10308    15-16      8
 */
typedef double tExportClock; /*Available to every compiler we can find*/
typedef unsigned char byte;
typedef byte tNodeName[21];  /*Pascal string, 21 bytes total, byte 0 is length*/
typedef struct
    {
     tExportClock Birthday;       /*Creation time, please do not change*/
     tExportClock EnteredQueue;   /*Time of node arrival, please do not change*/
     tNodeName Name;              /*Normally, the name of the start block*/
     byte Priority;               /*higher>higher priority, 15 is default*/
     byte UserDefined[16];        /*do as you please here*/
    }  tTransactionData;

void FAR PASCAL DLLProcCall
    (
     int Action,                   /*what is being done at the moment*/
     tExportClock Clock,           /*simulation clock reading (NOTE)*/
     tNodeName *DLL_Handle,        /*The handle you gave in the setup*/
     tExportClock *Delay,          /*Hold transaction at this process*/
     int *Status,                  /*flag you set to tell what to do next*/
     tTransactionData *Transaction /*address of the transaction record*/
    );

  /*action constants - What the simulator is doing.*/

  /*These are called individually*/
    #define Edit               0    /*user has pressed the edit button*/
    #define TransactionStart   1    /*if you have a constructor*/
    #define ConnectorProbe     2    /*transaction ready to move over connector*/
    #define TransactionStop    3    /*if you have a destructor*/
    #define SetDelay           4    /*Process is scheduling release*/

  /*You may want the user to be able to edit parameters in the DLL. If so,
    the following give the hooks you need.
    These are "Broadcast"*/
    #define StartLoad         11    /*get ready to load model from disk*/
    #define Load              12    /*load object*/
    #define EndLoad           13    /*finished loading*/
    #define StartSave         14    /*get ready to save to disk*/
    #define Save              15    /*save object*/
    #define EndSave           16    /*finished saving*/
    #define StartRun          17    /*user has pressed the "run" button (NOTE)*/
    #define RunComplete       18    /*Model run has finished*/
    #define DestroyModel      19    /*Close any open files, etc. */

  /*status constants - values you return
    A start block will call this procedure for each clock tick. It will
    repeat the call until NoAction is returned in the status parameter. The
    purpose is to allow for multiple transactions to be started at a single
    clock tick. */
    #define NoAction          100    /*do not start a transaction*/
    #define Start             101    /*start a transaction and call again(TransactionStart)*/
    #define SetDirtyFlag      102    /*Model has been changed(Edit)*/

   /* NOTE:
     Any status < 0 will be interpreted as an unrecoverable error. An
     exception will be raised, a message giving the status will be shown,
     and the model will be reset.

     When Action = StartRun the value passed in Clock is the size of the
     Clock Tick (heartbeat).
   */


