unit Dllif;

interface
type
{ From the manual:
    Type           Range                  Digits    Bytes
   Double   5.0 * 10-324 .. 1.7 * 10308    15-16      8
 }
  tExportClock = double; {Available to every compiler we can find}
  tNodeName = string[20]; {Pascal string, 21 bytes total, byte 0 is the length}
type
  tTransactionData = record
    Birthday: tExportClock;       {Creation time, please do not change}
    EnteredQueue: tExportClock;   {Time of node arrival, please do not change}
    Name: tNodeName;              {Normally, the name of the start block}
    Priority: byte;               {higher=>higher priority, 15 is default}
    UserDefined: array [0 .. 15] of byte;  {do as you please here}
  end;

  DLLProcCall = procedure
    (
      Action: integer;                   {what is being done at the moment}
      Clock: tExportClock;               {simulation clock reading (NOTE)}
      var DLL_Handle: tNodeName;         {The handle you gave in the setup}
      var Delay: tExportClock;           {Hold transaction at this process}
      var Status: integer;               {flag you set to tell what to do next}
      var Transaction: tTransactionData  {address of the transaction record}
    );

const

  {action constants - What the simulator is doing.}

  {These are called individually}
      Edit             =  0;    {user has pressed the edit button}
      TransactionStart =  1;    {if you have a constructor}
      ConnectorProbe   =  2;    {transaction ready to move over connector}
      TransactionStop  =  3;    {if you have a destructor}
      SetDelay         =  4;    {Process is scheduling release}

  {You may want the user to be able to edit parameters in the DLL. If so,
   the following give the hooks you need.
   These are "Broadcast"}
      StartLoad        = 11;    {get ready to load model from disk}
      Load             = 12;    {load object}
      EndLoad          = 13;    {finished loading}
      StartSave        = 14;    {get ready to save to disk}
      Save             = 15;    {save object}
      EndSave          = 16;    {finished saving}
      StartRun         = 17;    {user has pressed the "run" button (NOTE)}
      RunComplete      = 18;    {Model run has finished}
      DestroyModel     = 19;    {Close any open files, etc.}

  {status constants - values you return
   A start block will call this procedure for each clock tick. It will
   repeat the call until NoAction is returned in the status parameter. The
   purpose is to allow for multiple transactions to be started at a single
   clock tick. }
      NoAction         = 100;    {do not start a transaction}
      Start            = 101;    {start a transaction and call again(TransactionStart)}
      SetDirtyFlag     = 102;    {Model has been changed(Edit)}

   { * NOTE:

     Any status < 0 will be interpreted as an unrecoverable error. An
     exception will be raised, a message giving the status will be shown,
     and the model will be reset.

     When Action = StartRun the value passed in Clock is the size of the
     Clock Tick (heartbeat).
   }
implementation
end.
